<?php
/**
 * Popunder Popup
 *
 * @package 	Popunder Popup
 * @subpackage 	Popunder Popup
 * @version   	1.0
 * @author    	Gopi Ramasamy
 * @copyright 	Copyright (C) 2010 - 2014 www.gopiplus.com, LLC
 * @license   	http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 *
 * http://www.gopiplus.com/extensions/2014/05/popunder-popup-joomla-plugin/
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.plugin.plugin');

class plgSystempopunderpopup extends JPlugin
{
	function __construct(&$subject, $config)
    {
        parent::__construct($subject, $config);
        $this->app = JFactory::getApplication();
    }
	
	function onAfterInitialise()
    {
		if( $this->app->isAdmin() ) return;
		if( $this->isRenderTrue() != "SHOW" ) return;
		
		$pp_session = $this->params->get('pp_session', 'NO');
		if($pp_session <> "YES")
		{
			$pp_display = "YES";
		}
		elseif($pp_session == "YES" && isset($_SESSION['pp_session']) <> "YES")
		{
			$pp_display = "YES";
		}
		else if($pp_session == "YES" && isset($_SESSION['pp_session']) == "YES")
		{
			$pp_display = "NO";
		}
		
		if($pp_display == "YES")
		{
			$this->loadPopunderPopup();
			$_SESSION['pp_session'] = "YES";
		}
	}
	
	function onAfterRender()
    {
		if( $this->app->isAdmin() ) return;
		if( $this->isRenderTrue() != "SHOW" ) return;
		
		$doc = JFactory::getDocument();
        $docType = $doc->getType();
		if( $docType != 'html' ) return;

        $body = JResponse::getBody();
		
		$pattern = "/<\/?body+((\s+(\w|\w[\w-]*\w)(\s*=\s*(?:\".*?\"|'.*?'|[^'\">\s]+))?)+\s*|\s*)\/?>/";

        preg_match($pattern, $body, $match);

		$html = '<input name="openpopunder" id="openpopunder" value="YES" type="hidden">';
		
        $body = str_replace($match[0], $match[0] . $html, $body);

        JResponse::setBody($body);
	}
	
	function loadPopunderPopup()
    {
		$doc = JFactory::getDocument();
		
		$pp_width = $this->params->get('pp_width', '70');
		$pp_height = $this->params->get('pp_height', '70');	
		$pp_url1 = $this->params->get('pp_url1', 'http://www.example.com');
		$pp_url2 = $this->params->get('pp_url2', 'http://www.example.com');
		$pp_url3 = $this->params->get('pp_url3', 'http://www.example.com');
		
		$randompick = rand(1, 3);
		if($randompick == 1 && $pp_url1 <> "")
		{
			$pp_url = $pp_url1;
		}
		elseif($randompick == 2 && $pp_url2 <> "")
		{
			$pp_url = $pp_url2;
		}
		elseif($randompick == 3 && $pp_url3 <> "")
		{
			$pp_url = $pp_url3;
		}
		else
		{
			$pp_url = "http://www.example.com";
		}
		
		$pp_session = $this->params->get('pp_session', 'YES');
		
		if( !is_numeric($pp_width) )
		{
			$pp_width = 70;
		}
		
		if( !is_numeric($pp_height) )
		{
			$pp_height = 70;
		}
		
$pp_js = "(function($) 
{
$.popunder = function(sUrl) {
	var bSimple = $.browser.msie,
		run = function() {
			$.popunderHelper.open(sUrl, bSimple);
		};
	(bSimple) ? run() : window.setTimeout(run, 1);
	return $;
};

$.popunderHelper = {
	rand: function(name, rand) {
		var p = (name) ? name : 'pu_';
		return p + (rand === false ? '' : Math.floor(89999999*Math.random()+10000000));
	},

	open: function(sUrl, bSimple) {
		var _parent = self,
			sToolbar = (!$.browser.webkit && (!$.browser.mozilla || parseInt($.browser.version, 10) < 12)) ? 'yes' : 'no',
			sOptions,
			popunder;

		if (top != self) {
			try {
				if (top.document.location.toString()) {
					_parent = top;
				}
			}
			catch(err) { }
		}
		
		var w = $pp_width;
		var h = $pp_height;
		var livew = screen.availWidth;
		var liveh = screen.availHeight;
		var showw = (w/100) * livew;
		var showh = (h/100) * liveh;

		sOptions = 'toolbar=' + sToolbar + ',scrollbars=yes,location=yes,statusbar=yes,menubar=no,resizable=1,width=' + showw.toString();
		sOptions += ',height=' + showh.toString() + ',screenX=0,screenY=0,left=0,top=0';

		popunder = _parent.window.open(sUrl, $.popunderHelper.rand(), sOptions);
		if (popunder) {
			popunder.blur();
			if (bSimple) {
				window.focus();
				try { opener.window.focus(); }
				catch (err) { }
			}
			else {
				popunder.init = function(e) {
					with (e) {
						(function() {
							if (typeof window.mozPaintCount != 'undefined' || typeof navigator.webkitGetUserMedia === 'function') {
								var x = window.open('about:blank');
								x.close();
							}

							try { opener.window.focus(); }
							catch (err) { }
						})();
					}
				};
				popunder.params = {
					url: sUrl
				};
				popunder.init(popunder);
			}
		}

		return true;
	}
};
})(jQuery);

function iframepopupwidow(sUrl)
{
	jQuery('#openpopunder').ready(function() {
		jQuery.popunder(sUrl);
	});
}";
		
		$pp_js = $pp_js . 'document.onclick = function() 
		{ 
			var openpopunder = document.getElementById("openpopunder");
			if( openpopunder.value == "YES" )
			{
				document.getElementById("openpopunder").value = "NO";
				iframepopupwidow("'.$pp_url.'");
			}
		};';
		$doc->addScriptDeclaration($pp_js);
    }
	
	function isRenderTrue()
    {
		$returnstatus = "DONTSHOW";
		$page = $this->params->get('pp_loadpage', 'all');
        switch( $page )
        {
			case 'all':
				$returnstatus = "SHOW";
				break;
            case 'homepage':
				$menu = $this->app->getMenu();
				if ($menu->getActive() == $menu->getDefault())
                {
					$returnstatus = "SHOW";
                }
				else
				{
					$returnstatus = "DONTSHOW";
                }
				break;
			default:
				$returnstatus = "SHOW";
				break;
		}
		return $returnstatus;
	}
}
?>